﻿using System.Threading;
using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            Thread thread = Thread.CurrentThread;

            this.DataContext = new
            {
                ThreadId = thread.ManagedThreadId
            };

            this.button.Click += button_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 새 윈도우 생성 버튼 클릭시 처리하기 - button_Click(sender, e)

        /// <summary>
        /// 새 윈도우 생성 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void button_Click(object sender, RoutedEventArgs e)
        {
            Thread thread = new Thread
            (
                () =>
                {
                    MainWindow window = new MainWindow();

                    window.Closed += (sender2, e2) => window.Dispatcher.InvokeShutdown();

                    window.Show();
                    
                    System.Windows.Threading.Dispatcher.Run();
                }
            );

            thread.SetApartmentState(ApartmentState.STA);

            thread.Start();
        }

        #endregion
    }
}